////////////////////////////////////////////////////////////////////////////
//
//      Name:             MainDlgProc.cpp
//      Erstellt:         21.05.2005
//      Letzte nderung:  15.12.2005
//
//      Beschreibung:     Prozedur des Hauptdialogs
//
////////////////////////////////////////////////////////////////////////////

#include "..\\main\\main.h"
#include <windows.h>
#include "..\\main\\calc.h"

// ---------------------------------------------------------------------- \\

BOOL CALLBACK MainDlgProc ( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
  static bool bChanged, bSaved;
  
  switch ( msg )
  {
    case WM_INITDIALOG:
    {  
      // Variablen initialisieren
      globals().hMainDlg = hDlg;
      bChanged = false;
      bSaved = false;
      
      // Einstellungen initialisieren
      SendDlgItemMessage ( hDlg, IDC_TYPE, CB_ADDSTRING, 0, (LPARAM) "Erste DWZ" );
      SendDlgItemMessage ( hDlg, IDC_TYPE, CB_ADDSTRING, 0, (LPARAM) "DWZ-Vernderung" );
      SendDlgItemMessage ( hDlg, IDC_TYPE, CB_ADDSTRING, 0, (LPARAM) "Erste ELO" );
      SendDlgItemMessage ( hDlg, IDC_TYPE, CB_ADDSTRING, 0, (LPARAM) "ELO-Vernderung" );
      SendDlgItemMessage ( hDlg, IDC_RATING, EM_SETLIMITTEXT, 4, 0 );
      SendDlgItemMessage ( hDlg, IDC_AGE, EM_SETLIMITTEXT, 2, 0 );
      SendDlgItemMessage ( hDlg, IDC_COUNT, EM_SETLIMITTEXT, 2, 0 );
            
      // Gegner initialisieren       
      for ( int i = 1; i <= EDIT_COUNT; ++i )
      {
        SendDlgItemMessage ( hDlg, IDC_RATINGS+i, EM_SETLIMITTEXT, 4, 0 );
        SendDlgItemMessage ( hDlg, IDC_SCORE+i, CB_ADDSTRING, 0, (LPARAM) "0" );
        SendDlgItemMessage ( hDlg, IDC_SCORE+i, CB_ADDSTRING, 0, (LPARAM) "0,5" );
        SendDlgItemMessage ( hDlg, IDC_SCORE+i, CB_ADDSTRING, 0, (LPARAM) "1" );
      }      
      SendMessage ( hDlg, WMU_CLEAR, 0, 0 );


      // Konfiguration laden & Steuerelemente initailisieren
      if ( ReadINI ( &globals().settings ) )
      {
        SendDlgItemMessage ( hDlg, IDC_TYPE, CB_SETCURSEL, globals().settings.iLastType, 0 );           
        SetDlgItemInt ( hDlg, IDC_RATING, globals().settings.iLastRating, 0 );           
        SetDlgItemInt ( hDlg, IDC_AGE, globals().settings.iLastAge, 0 );           
        SetDlgItemInt ( hDlg, IDC_COUNT, globals().settings.iLastCount, 0 );           
      }
      else
      {
        SendDlgItemMessage ( hDlg, IDC_TYPE, CB_SETCURSEL, TYPE_DWZ, 0 );   
        SetDlgItemInt ( hDlg, IDC_COUNT, 6, 0 );        
        globals().settings.szExportFile [0] = 0;
        globals().settings.szFilename [0] = 0;
      }
      SendMessage ( hDlg, WM_COMMAND, MAKEWPARAM ( IDC_TYPE, LBN_SELCHANGE ), 0 );
            
      return true;
    }
       
    case WM_COMMAND:
      switch ( LOWORD ( wParam ) )
      {
        // Neue Datei
        case IDC_FILE_NEW:
          if ( MainDlgProc ( hDlg, WMU_QUERY, 0, 0 ) )
            SendMessage ( hDlg, WMU_CLEAR, 0, 0 );
          bSaved = false;
          return true;
          
        // Datei ffnen
        case IDC_FILE_OPEN:
        {
          CALC_INPUT calc;
          int iError;
          
          // Speicher-Abfrage
          if ( !MainDlgProc ( hDlg, WMU_QUERY, 0, 0 ) )
            return true;
            
          // Laden
          if ( ExploreForFile ( false, SZ_OPEN_TITLE, globals().settings.szFilename, MY_MAX_PATH, hDlg ) )
          {
            if ( iError = CalcLoad ( globals().settings.szFilename, &calc ) )
              return Alert ( hDlg, iError );
            SendMessage ( hDlg, WMU_SET, 0, (LPARAM) &calc );
            bChanged = false;
            bSaved = true;
          }
          return true;
        }
        
        // Datei speichern
        case IDC_FILE_SAVE:
        {
          CALC_INPUT calc;
          int iError;
          
          // Dateiname gltig?
          if ( bSaved )
          {
            // Datei schreiben
            SendMessage ( hDlg, WMU_STORE, 0, (LPARAM) &calc );
            if ( iError = CalcSave ( globals().settings.szFilename, &calc ) )
              return Alert ( hDlg, iError );
          }
          else
            // Speichern-Dialog
            SendMessage ( hDlg, WM_COMMAND, IDC_FILE_SAVEAS, 0 );
          
          return true;
        }
          
        // Datei speichern unter
        case IDC_FILE_SAVEAS:
        {
          // Speichern
          if ( ExploreForFile ( true, SZ_SAVE_TITLE, globals().settings.szFilename, MY_MAX_PATH, hDlg ) )
          {
            bSaved = true;
            SendMessage ( hDlg, WM_COMMAND, IDC_FILE_SAVE, 0 ); 
          }
          return true;          
        }        
        
        // Programm beenden 
        case IDCANCEL:
          // Speichern?
          if ( !MainDlgProc ( hDlg, WMU_QUERY, 0, 0 ) )
            return true;

          // Letzte Werte speichern
          globals().settings.iLastType = SendDlgItemMessage ( hDlg, IDC_TYPE, CB_GETCURSEL, 0, 0 );
          globals().settings.iLastRating = GetDlgItemInt ( hDlg, IDC_RATING, NULL, true );
          globals().settings.iLastAge = GetDlgItemInt ( hDlg, IDC_AGE, NULL, true );
          globals().settings.iLastCount = GetDlgItemInt ( hDlg, IDC_COUNT, NULL, true );
          
          // Konfiguration sichern
          WriteINI ( &globals().settings );

          // Programm beenden
          EndDialog ( hDlg, 0 );
          return true;
                  
        // ----------------------------------------------------------- \\
        
        // Berechnen
        case IDOK:
        {  
          CALC_INPUT in;
          CALC_RESULT out;
          char szText [5000];
          int iError;
          
          ZeroMemory ( (char *) &out, sizeof ( CALC_RESULT ) );
          
          // Daten holen
          SendMessage ( hDlg, WMU_STORE, 0, (LPARAM) &in );
          
          // Daten-Nachschlag
          if ( in.iType == TYPE_ELO && in.iCount > 30 && in.iRo > 2200 && in.iRo < 2400 )
            in.iAge = ( MessageBox ( hDlg, SZ_ELO24_MSG, SZ_QUERY_TITLE, MB_YESNO | MB_ICONQUESTION ) == IDYES );
          
          // Generieren
          if ( ( iError = CalcRating ( in, &out, 0 ) ) != ERROR_SUCCESS )
            return Alert ( hDlg, iError );
          CalcGenerateText ( in, out, szText, 5000 );         

          // Anzeigen
          DialogBoxParam ( globals().hInst, "TextDlg", hDlg, TextDlgProc, (LPARAM) &szText );       
          return true;    
        }

        // Spieler suchen
        case IDC_EDIT_FIND:
          DialogBox ( globals().hInst, "FindDlg", hDlg, FindDlgProc );
          return true;

        // ----------------------------------------------------------- \\
        
        // Hilfe
        case IDC_HELP_HELP:
          DialogBoxParam ( globals().hInst, "TextDlg", hDlg, TextDlgProc, (LPARAM) SZ_HELP );
          return true;
          
        // Programminfo
        case IDC_HELP_INFO:
          DialogBoxParam ( globals().hInst, "TextDlg", hDlg, TextDlgProc, (LPARAM) SZ_INFO );
          return true;
          
        // Selbstreparieren
        case IDC_HELP_REPAIR:
        {
          char szBuffer [MY_MAX_PATH];
          if ( GetINIFilename ( szBuffer, MY_MAX_PATH ) ) 
            if ( DeleteFile ( szBuffer ) )           
            {
              MessageBox ( hDlg, "Programm repariert!?!", SZ_QUERY_TITLE, MB_ICONINFORMATION );
              EndDialog ( hDlg, 0 );
            }
          return true;
        }
         
        // Homepage
        case IDC_HELP_HOME:
          ShellExecute( NULL, SZ_SHELL_OPEN, SZ_HOMEPAGE, NULL, NULL, SW_SHOW );    
          return true;

        // ----------------------------------------------------------- \\

        // Typ gendert
        case IDC_TYPE:
          if ( HIWORD ( wParam ) == CBN_SELCHANGE )
          {
            // Ausgewhlter Typ?
            int iSel = SendDlgItemMessage ( hDlg, IDC_TYPE, CB_GETCURSEL, 0, 0 ); 
            
            // Alle ausblenden            
            for ( int i = IDC_RATING; i <= IDC_COUNT2_LBL; ++i )
              ShowWindow ( GetDlgItem ( hDlg, i ), SW_HIDE );

            // Nur bestimmte einblenden
            if ( iSel == TYPE_DWZ )
              for ( int i = IDC_RATING; i <= IDC_COUNT_LBL; ++i )
                ShowWindow ( GetDlgItem ( hDlg, i ), SW_SHOW );
            if ( iSel == TYPE_ELO )
            {
              ShowWindow ( GetDlgItem ( hDlg, IDC_RATING ), SW_SHOW );
              ShowWindow ( GetDlgItem ( hDlg, IDC_RATING_LBL ), SW_SHOW );
              ShowWindow ( GetDlgItem ( hDlg, IDC_COUNT ), SW_SHOW );
              ShowWindow ( GetDlgItem ( hDlg, IDC_COUNT2_LBL ), SW_SHOW );
            }
          } 
          return true;
        
        // Gegner gendert
        default:
        {
          int id = LOWORD ( wParam ), msg = HIWORD ( wParam );
          if ( ( id > IDC_RATINGS && id <= IDC_RATINGS + EDIT_COUNT && msg == EN_CHANGE )
            || ( id > IDC_SCORE && id <= IDC_SCORE + EDIT_COUNT && msg == CBN_SELCHANGE ) ) 
            bChanged = true;
        }
      }
      return true;

    // ----------------------------------------------------------- \\
   
    // Felder leeren
    case WMU_CLEAR:
    {
      for ( int i = 1; i <= EDIT_COUNT; ++i )
      {
        SetDlgItemText ( hDlg, IDC_RATINGS + i, "" );
        SendDlgItemMessage ( hDlg, IDC_SCORE + i, CB_SETCURSEL, 1, 0 );
      }
      bChanged = false;
      return true; 
    }
    
    // Felder einlesen
    case WMU_STORE:
    {
      BOOL bSuccess;
      CALC_INPUT * calc = (CALC_INPUT *) lParam;
      
      calc->iType = SendDlgItemMessage ( hDlg, IDC_TYPE, CB_GETCURSEL, 0, 0 );
      calc->iRo = GetDlgItemInt ( hDlg, IDC_RATING, NULL, true );
      calc->iAge = GetDlgItemInt ( hDlg, IDC_AGE, NULL, true );
      calc->iCount = GetDlgItemInt ( hDlg, IDC_COUNT, NULL, true );

      for ( int i = 0; i < EDIT_COUNT; ++i )
      {
        calc->iRatings [i] = GetDlgItemInt ( hDlg, IDC_RATINGS + 1 + i, &bSuccess, true );
        if ( !bSuccess ) calc->iRatings [i] = 0;
        calc->iScore [i] = SendDlgItemMessage ( hDlg, IDC_SCORE + 1 + i, CB_GETCURSEL, 0, 0 );
      }       
      return true;  
    }
    
    // Felder setzen
    case WMU_SET:
    {
      CALC_INPUT * calc = (CALC_INPUT *) lParam;

      SendDlgItemMessage ( hDlg, IDC_TYPE, CB_SETCURSEL, calc->iType, 0 );
      SetDlgItemInt ( hDlg, IDC_RATING, calc->iRo, false );
      SetDlgItemInt ( hDlg, IDC_AGE, calc->iAge, false );
      SetDlgItemInt ( hDlg, IDC_COUNT, calc->iCount, false );

      for ( int i = 0; i < EDIT_COUNT; ++i )
      {
        if ( calc->iRatings [i] )
          SetDlgItemInt ( hDlg, IDC_RATINGS + 1 + i, calc->iRatings [i], false );
        else
          SetDlgItemText ( hDlg, IDC_RATINGS + 1 + i, "" );
        SendDlgItemMessage ( hDlg, IDC_SCORE + 1 + i, CB_SETCURSEL, calc->iScore [i], 0 );
      }       
      return true;  
    }  
    
    // Speicher-Abfrage
    case WMU_QUERY:
    {
      int iRet;
      if ( bChanged )
      {
        iRet = MessageBox ( hDlg, SZ_QUERY_MSG, SZ_QUERY_TITLE, MB_YESNOCANCEL | MB_ICONWARNING );
        if ( iRet == IDYES )
        {
          SendMessage ( hDlg, WM_COMMAND, IDC_FILE_SAVE, 0 );
          return true;
        }
        else if ( iRet == IDCANCEL )
          return false;
      }
      return true;
    }   
  }   
  return false;
}     

// ---------------------------------------------------------------------- \\
