////////////////////////////////////////////////////////////////////////////
//
//      Name:             TextDlgProc.cpp
//      Erstellt:         24.11.2005
//      Letzte nderung:  12.12.2005
//
//      Beschreibung:     Prozedur des Ausgabedialogs
//
////////////////////////////////////////////////////////////////////////////

#include "..\\main\\main.h"
#include <windows.h>
#include <fstream>
#include <malloc.h>
using namespace std;

// ---------------------------------------------------------------------- \\

/*
// Text aus dem Dialog durcken (teils aus "Petzold: Windowsprogrammierung", S.602 )
bool PrintTextDlg ( HWND hDlg, HWND hEdit )
{
  // Variablen
  DOCINFO       di = { sizeof ( DOCINFO ) };
  PRINTDLG      pd;
  TEXTMETRIC    tm;
  WORD          iColCopy, iNoiColCopy;
  bool          bSuccess;
  char *        szBuffer;
  int           yChar, iCharsPerLine,  iLinesPerPage, iTotalLines, 
                iTotalPages, iPage, iLine, iLineNum;

  // Druck-Dialog
  ZeroMemory ( &pd, sizeof ( PRINTDLG ) );
  pd.lStructSize            = sizeof ( PRINTDLG );
  pd.hwndOwner              = hDlg;
  pd.Flags                  = PD_ALLPAGES | PD_COLLATE | PD_RETURNDC | PD_NOSELECTION;
  pd.nCopies                = 1;
  if ( !PrintDlg ( &pd ) ) return true;
  if ( !( iTotalLines = SendMessage ( hEdit, EM_GETLINECOUNT, 0, 0 ) ) ) return true;
  
  // Zeilenzahl, Seitenzahl berechnen
  GetTextMetrics ( pd.hDC, &tm );
  yChar = tm.tmHeight + tm.tmExternalLeading;
  iCharsPerLine = GetDeviceCaps ( pd.hDC, HORZRES ) / tm.tmAveCharWidth;
  iLinesPerPage = GetDeviceCaps ( pd.hDC, VERTRES ) / yChar;
  iTotalPages = (iTotalLines + iLinesPerPage - 1 ) / iLinesPerPage;

  // Vorbereitungen
  bSuccess = true;
  szBuffer = (char *) malloc ( sizeof ( char ) * ( iCharsPerLine + 1 ) );
  EnableWindow ( hDlg, false );
  
  // Ausdrucken
  di.lpszDocName = SZ_DOCNAME;
  if ( StartDoc ( pd.hDC, &di ) > 0 )
  {
    // Sortierraihenfolge und Anzahl der Kopien
    for ( iColCopy = 0; iColCopy < ((WORD) pd.Flags & PD_COLLATE ? 1 : pd.nCopies ); ++iColCopy )
    {
      for ( iPage = 0; iPage < iTotalPages; ++iPage )
      {
        for ( iNoiColCopy = 0; iNoiColCopy < ( pd.Flags & PD_COLLATE ? 1 : pd.nCopies ); ++iNoiColCopy )
        {
          // Seitenstart
          if ( StartPage ( pd.hDC ) < 0 )
          {
            bSuccess = false;
            break;
          }
          
          // Ausgabe (zeilenweise)
          for ( iLine = 0; iLine < iLinesPerPage; ++iLine )
          {
            iLineNum = iLinesPerPage * iPage + iLine;
            if ( iLineNum > iTotalLines )
              break;
            *(int *) szBuffer = iCharsPerLine;
            TextOut ( pd.hDC, 0, yChar * iLine, szBuffer, 
                  (int) SendMessage ( hEdit, EM_GETLINE, iLineNum, (LPARAM) szBuffer ) );
          }
          
          if ( EndPage ( pd.hDC ) < 0 )
          {
            bSuccess = false;
            break;
          }
        }
        if ( !bSuccess ) break;
      }
      if ( !bSuccess ) break;
    }
  }
  else
    bSuccess = false;
    
  // Drucken beenden
  if ( bSuccess ) EndDoc ( pd.hDC );
  EnableWindow ( hDlg, true );
  free ( szBuffer );
  DeleteDC ( pd.hDC );
  
  return bSuccess;
} 
*/

// ---------------------------------------------------------------------- \\

// Text speichern
bool ExportTextDlg ( char * szText, char * szFilename )
{
  ofstream out ( szFilename, ios::out );
  if ( out.rdstate () != ios::goodbit )
    return false;
  out << szText;
  out.close ();
  return true;
}

// ---------------------------------------------------------------------- \\

BOOL CALLBACK TextDlgProc ( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
  static char * szText;
  
  switch ( msg )
  {
    case WM_INITDIALOG:
    {  
      // Variablen setzen
      szText = (char *) lParam;
      
      // Text setzen
      SetDlgItemText ( hDlg, IDC_EDIT, szText );
      SendDlgItemMessage ( hDlg, IDC_EDIT, EM_SETSEL, (WPARAM) -1, (LPARAM) -1 );

      return true;
    }
       
    case WM_COMMAND:
      switch ( LOWORD ( wParam ) )
      {
        // Dialog beenden
        case IDOK:
        case IDCANCEL:
          EndDialog ( hDlg, 0 );
          return true;
        
        // Text drucken
        case IDC_PRINT:
        {
          // PrintTextDlg ( hDlg, GetDlgItem ( hDlg, IDC_EDIT ) );
          char szTempFile [MY_MAX_PATH];
          if ( GetTempPath ( MY_MAX_PATH, szTempFile ) )
          {
            lstrcat ( szTempFile, SZ_TEMP_FILE );
            ExportTextDlg ( szText, szTempFile );
            ShellExecute( NULL, SZ_SHELL_PRINT, szTempFile, NULL, NULL, SW_HIDE );            
          }     
          else
            return Alert ( hDlg, 8 );     
          return true;
        }
          
        // Text exportieren
        case IDC_EXPORT:
        {
          if ( ExploreForFile ( true, SZ_EXPORT_TITLE, globals().settings.szExportFile, 
                                  MY_MAX_PATH, hDlg, SZ_EXPORT1, SZ_EXPORT2 ) )
            if ( !ExportTextDlg ( szText, globals().settings.szExportFile ) )
              return Alert ( hDlg, 7 );
          return true;    
        }      
      }
  }   
  return false;
}     

// ---------------------------------------------------------------------- \\

