////////////////////////////////////////////////////////////////////////////
//
//      Name:             calc.h
//      Erstellt:         21.05.2005
//      Letzte nderung:  12.12.2005
//
//      Beschreibung:     Deklaration der Klasse CALC
//
////////////////////////////////////////////////////////////////////////////

#ifndef _CALC_H
#define _CALC_H

#include "..\\main\\main.h"

// ---------------------------------------------------------------------- \\

// Konstanten und Makros
#define CALC_E                    2.718281828
#define CALC_FALSE                -99
#define CALC_NOTUSED              -100
#define OPP_COUNT                 EDIT_COUNT

// ---------------------------------------------------------------------- \\

// Daten fr die Berechnung
struct CALC_INPUT
{
  char iSignatur;
  
  int iType;
  int iRo;
  int iAge;
  int iCount;
  
  int iRatings [OPP_COUNT];    
  int iScore [OPP_COUNT];
};

// Alte Formate
class CALC_INPUT_V1
{
 public:
  char iSignatur;
  int iAge;
  int iRo;
  double dScore [11];
  int iRatings [11];    
};

// Ergebnisse der Berechnung
struct CALC_RESULT
{
  int iRo;
  int iN;  
  int iRc;
  double dW;
  double dWe;
  int iRh;
  int iRn;
}; 

// Zeile in der Wertetabelle
struct CALC_ROW
{
  int iMin;
  int iMax;
  double dBigger;
  double dSmaller;
};
  
// ---------------------------------------------------------------------- \\

// Funktionen
bool CalcGenerateText ( const CALC_INPUT &, const CALC_RESULT &, char *, int );
int CalcRating ( const CALC_INPUT &, CALC_RESULT *, int ); 

int CalcRh ( CALC_ROW *, const CALC_INPUT &, const CALC_RESULT & );
double CalcGetPD ( CALC_ROW *, int, int );
int CalcGetD ( CALC_ROW *, double );

int CalcLoad ( char *, CALC_INPUT * );
int CalcSave ( char *, CALC_INPUT * );

// ---------------------------------------------------------------------- \\

#endif

