////////////////////////////////////////////////////////////////////////////
//
//      Name:             main.cpp
//      Erstellt:         14.11.2005
//      Letzte nderung:  14.11.2005
//
//      Beschreibung:     Grundstzliche Funktionen
//
////////////////////////////////////////////////////////////////////////////

#include "main.h"
#include <windows.h>
#include <fstream.h>

// ---------------------------------------------------------------------- \\
// Grundstzliche Funktionen
// ---------------------------------------------------------------------- \\

// Fehlermeldung ausgeben
bool AlertEx ( HWND hwnd, int iError, char * szFile, int iLine )
{
  // Variablen
  char szBuffer [1000];
  char szBuffer2 [2000];
  int iLastError;
  
  // Fehlerinformation konstruieren
  iLastError = GetLastError ();  
  LoadString ( globals().hInst, IDS_ERRORS + iError, szBuffer, 1000 );
  wsprintf ( szBuffer2, SZ_ALERT, szBuffer, iError, iLastError, szFile, iLine );
  
  // Ausgabe
  return MessageBox ( hwnd, szBuffer2, "Fehler", MB_ICONSTOP ); 
}

// ---------------------------------------------------------------------- \\

// ffnen-/Speichern-Dialog anzeigen
BOOL ExploreForFile ( bool bSave, char * szTitle, char * szBuffer, int iBuffer, 
  HWND hwnd = NULL, char * szFil1 = SZ_OPENSAVE1, char * szFil2 = SZ_OPENSAVE2 )
{
  // Struktur initialisieren
  OPENFILENAME ofn;
  ZeroMemory(&ofn, sizeof(OPENFILENAME));
  if ( !hwnd ) hwnd = globals().hMainDlg;

  // Einstellungen
  ofn.lStructSize = sizeof (OPENFILENAME);
  ofn.hInstance = globals().hInst;
  ofn.nMaxFile = iBuffer;
  ofn.lpstrFile = szBuffer;
  ofn.hwndOwner = hwnd;
  ofn.lpstrTitle = szTitle;
  ofn.lpstrFilter = szFil1;
  ofn.lpstrDefExt = szFil2;
  
  // Speichern- oder ffnen-Dialog?
  if ( bSave )
  {
    ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
    return GetSaveFileName (&ofn);
  }
  else
  {
    ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
    return GetOpenFileName (&ofn);
  }
}

// ---------------------------------------------------------------------- \\

// Hier werden die Globalen gespeichert
GLOBALS &globals ()
{
  static GLOBALS _globals;
  return _globals;
}

// ---------------------------------------------------------------------- \\
// INI-Funktionen
// ---------------------------------------------------------------------- \\

// Dateinamen fr Konfigurationsdatei holen
bool GetINIFilename ( char * szBuffer, int iBuffer )
{
  int iIndex;
  
  // Windows-Ordner
  GetWindowsDirectory ( szBuffer, iBuffer - 10 );
  iIndex = lstrlen ( szBuffer );
  if ( szBuffer [iIndex-1] != '\\' )
  {
    szBuffer [iIndex] = '\\';
    szBuffer [iIndex+1] = 0;
  }
  
  // Dateinamen anhngen
  lstrcat ( szBuffer, SZ_INI_FILE );
  return true;
}

// Konfigurationsdaten lesen
bool ReadINI ( SETTINGS * psettings )
{
  // Dateinamen holen
  char szBuffer [MY_MAX_PATH];
  if ( !GetINIFilename ( szBuffer, MY_MAX_PATH ) )
    return false;
  
  // Einlesen
  ifstream in ( szBuffer, ios::in | ios::binary );
  if ( in.rdstate () != ios::goodbit )
    return false;
  in.read ( (char *) psettings, sizeof ( SETTINGS ) );
  in.close ();
  return true;
}

// Konfiguration speichern
bool WriteINI ( SETTINGS * psettings )
{
  // Dateinamen holen
  char szBuffer [MY_MAX_PATH];
  if ( !GetINIFilename ( szBuffer, MY_MAX_PATH ) )
    return false;
    
  // Schreiben
  ofstream out ( szBuffer, ios::out | ios::binary );
  if ( out.rdstate () != ios::goodbit )
    return false;
  out.write ( (char *) psettings, sizeof ( SETTINGS ) );
  return true;
}

// ---------------------------------------------------------------------- \\

